;; The first three lines of this file were inserted by DrScheme. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "reader.ss" "plai" "lang")

;; Asignación de puntajes (Versi'on sin uso de listas):

(define (create-dict*)
  (letrec 
      ((curr-dict (λ (key) #f)) ;; 0,3 pts
       ;;(empty-dict (λ () (λ (key) #f)))
       
       (extend-dict (λ (key value dict) ;; 0,3 pts
                      (λ (searched-key) 
                        (cond 
                          ((eq? searched-key key) value)
                          (else (lookup-dict searched-key dict))))))
       
       (lookup-dict (λ (key dict) (dict key)))) ;; 0,3 pts
    
    (lambda (option) ;; 0,2 pts
      (cond
        ((eq? option 'insert) (λ (key value) (set! curr-dict (extend-dict key value curr-dict))))
        ((eq? option 'search) (λ (key) (lookup-dict key curr-dict)))
        ((eq? option 'delete) (error "Not allowed"))
        (else (error "Message not understood"))))))

(define (insert-dict* dict key value) ;; 0,2 pts
 (if (search-dict* dict key) (error "The key exists in the dictionary")
     ((dict 'insert) key value)))

(define (search-dict* dict key) ((dict 'search) key)) ;; 0,1 pts

(define (delete-dict* dict key) ((dict 'insert) key #f)) ;; 0,1 pts

(define mydict* (create-dict*))

(insert-dict* mydict* 5 "Cinco")
(insert-dict* mydict* 3 "Tres")
(insert-dict* mydict* 7 "Siete")

;;(insert-dict* mydict* 5 "Five") ;;--> Error!!

(test (search-dict* mydict* 3) "Tres")

(delete-dict* mydict* 7)

(test (search-dict* mydict* 7) #f)


;; Asignación de puntajes (Versi'on con uso de listas):

(define (create-dict)
  (letrec ((dict empty) ;; 0,3 pts
           
           (get-key (λ (my-dict) (first (first my-dict))))
           (get-value (λ (my-dict) (second (first my-dict))))
           
           (insert (λ (key value) ;; 0,2 pts
                     (if (search* key dict) (error "The key exists in the dictionary")
                         (set! dict (cons (list key value) dict)))))
           
           (search* (λ (searched-key my-dict) ;; 0,2 pts
                     (cond 
                       ((empty? my-dict) #f)
                       ((eq? (get-key my-dict) searched-key) (get-value my-dict))
                       (else (search* searched-key (rest my-dict))))))
           
           (delete* (λ (searched-key my-dict) ;; 0,2 pts
                     (cond 
                       ((empty? my-dict) my-dict)
                       ((eq? (get-key my-dict) searched-key) (rest my-dict))
                       (else (cons (first my-dict) (delete (rest my-dict)))))))
           
           (search (λ (searched-key) (search* searched-key dict))) ;; 0,1 pts
           
           (delete (λ (searched-key) (set! dict (delete* searched-key dict))))) ;; 0,1 pts
    
    (vector insert search delete))) ;; 0,1 pts


(define (insert-dict dict key value) ((vector-ref dict 0) key value)) ;; 0,1 pts
(define (search-dict dict key) ((vector-ref dict 1) key)) ;; 0,1 pts
(define (delete-dict dict key) ((vector-ref dict 2) key)) ;; 0,1 pts

(define mydict (create-dict))

(insert-dict mydict 5 "Cinco")
(insert-dict mydict 3 "Tres")
(insert-dict mydict 7 "Siete")

;; (insert-dict mydict 5 "Five") --> Error!!

(test (search-dict mydict 3) "Tres")

(delete-dict mydict 7)

(test (search-dict mydict 7) #f)